﻿/*
 * Copyright (c) 2017 Razeware LLC
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

using UnityEngine;

public class CameraLerpToTransform : MonoBehaviour
{
    public Transform cameraTrackTarget;

    public float cameraZDepth = -10f;

    public float maxX;

    public float maxY;

    public float minX;

    public float minY;

    public float trackingSpeed;

    // Use this for initialization
    void Start()
    {
    }

    // Update is called once per frame
    void Update()
    {
        if (cameraTrackTarget != null)
        {
            var newPosition = Vector2.Lerp(transform.position, cameraTrackTarget.position,
                Time.deltaTime * trackingSpeed);
            var camPosition = new Vector3(newPosition.x, newPosition.y, cameraZDepth);

            var v3 = camPosition;
            var newX = Mathf.Clamp(v3.x, minX, maxX);
            var newY = Mathf.Clamp(v3.y, minY, maxY);
            transform.position = new Vector3(newX, newY, cameraZDepth);
        }
    }
}